<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */

use JustKnit\Register\Register;

/**
 * JustKnitRegister
 *
 * Snippet which handles new subscriptions and processes register forms.
 *
 * @var modX $modx
 * @var Register $register
 * @var array $scriptProperties
 *
 * PROPERTIES
 * these values are used in class Login Processor & Logout Processor
 *
 * @var Login Processor
 *
 *     public $user
 *     public $username
 *     public $givenPassword
 *     public $rememberme
 *     public $lifetime
 *     public $loginContext
 *     public $addContexts
 *     public $isMgr
 *
 * @var Logout Processor
 *
 *     public $loginContext
 *     public $addContexts
 *     public $isMgr
 */
/**
 * @package justknit
 * @subpackage snippets
 */

$register = new Register($modx, $scriptProperties);  // ruft auf: src/Register/Register.php
$controller = $register->loadController('HardLoginLogout');  //darin diese Funktion
$output = $controller->run($scriptProperties);
return $output;
