<!--static tpl-->
[[- Template für die Berechnungs Seiten
* hat Burgermenü mit Untermenü, damit der User direkt zu den einzelnen Berechnungen kommt.
*
* id:
* name: Client
* wird verwendet für die Berechnungen
*
]]
<!DOCTYPE html>
<html lang="de-de">
    <head>
        <meta charset="[[++modx_charset]]">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="description" content="[[*description:len:gte=`155`:then=`[[*description:limit=`155`]] ...`:else=`[[*description]]`]]" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="theme-color" content="#212529">
        <meta name="apple-mobile-web-app-capable" content="yes">
        <meta name="apple-mobile-web-app-status-bar-style" content="black">
        <title>[[*pagetitle]][[*pagetitle:len:lte=`57`:then=` | [[++site_name]]`]]</title>
        <meta name="copyright"  content="Iris Hammer" />
        <base href="[[!++site_url]]" />
        <meta name="author" content="[[*editedby:userinfo=`fullname`]] - [[++site_url]]" />
        <meta name="robots" content="max-snippet:-1, max-image-preview:large, max-video-preview:-1"/>
        <meta http-equiv="last-modified" content="[[*editedon]]" />
        <!-- Favicon -->
        <link rel="icon" href="assets/components/justknit/img/icons/jkIcon.png">
        <!-- Bootstrap 5.3.0 -->
        <link rel="stylesheet" type="text/css" href="assets/components/justknit/css/bootstrap.min.css" />
        <link rel="stylesheet" type="text/css" href="assets/components/justknit/css/bootstrap-icons.css" />
        <link rel="stylesheet" type="text/css" href="assets/components/justknit/css/googlefonts.css" />
        <link rel="stylesheet" type="text/css" href="assets/components/justknit/css/justknit.basis.css" />
        <link rel="manifest" href="manifest.json">
        <!-- Icons -->
        <link rel="apple-touch-icon" href="assets/components/justknit/img/icons/icon-96x96.png">
        <link rel="apple-touch-icon" sizes="120x120" href="assets/components/justknit/img/icons/icon-120x120.png">
        <link rel="apple-touch-icon" sizes="152x152" href="assets/components/justknit/img/icons/icon-152x152.png">
        <link rel="apple-touch-icon" sizes="167x167" href="assets/components/justknit/img/icons/icon-167x167.png">
        <link rel="apple-touch-icon" sizes="180x180" href="assets/components/justknit/img/icons/icon-180x180.png">
    </head>
    <body>
<script>
    var kA = '';
   (localStorage.getItem('knitApp') !== null) ? kA = JSON.parse(localStorage.getItem('knitApp')) : kA.theme = "light";
    document.documentElement.dataset.appliedMode = kA.theme;
</script>
    [[!ClientData]][[-!getCalcData? &res=`[[*id]]`]]
        <header>
            <nav class="navbar fixed-top jk-topnav">
                <div class="container">
                    <div class="back-nav col-2">
                        <a class="back" href="[[GoBack]]" role="button" ><i class="bi bi-arrow-left-short"></i><span hidden>Back</span></a>
                    </div>
                    <div class="header-content text-center position-absolute top-50 start-50 translate-middle">
                        <span class="page-title">[[*pagetitle]]</span>
                    </div>

            [[!+isLoggedIn:is=`1`:then=`
                [[$jkBurgerOffCanvasCalc]]
                [[-<div class="user-login fs-4"><a href="[[~12? &service=`logout`]]" title="Logout"><span hidden>Logout</span><i class="bi bi-box-arrow-right"></i></a></div>]]
            `:else=`
                <div class="user-login fs-4"><a href="[[~12]]" title="Login"><span hidden>Login</span><i class="bi bi-person"></i></a></div>
            `]]
                </div>
            </nav>
        </header>
        <form id="calc-[[*alias]]" class="freecalc" action="[[~[[*id]]]]" method="post">
        <main class="fixed-top-nav fixed-bottom-nav">
            <div class="container">
                [[*content]]
            </div>
        </main>
        <footer>
            <nav class="navbar fixed-bottom jk-bottomnav">
                <div class="container justify-content-evenly">
[[- Hier muss noch integriert werden, dass der SpeichernButton (addBtn) nur angezeigt wird, wenn product.product_name != 'Basis'
    Also eigentlich so: wenn Basis dann calsBtn sonst addBtn  ]]
                    <button id="calcBtn" type="button" class="btn btn-info  mb-2">[[%justknit.btn_calc? &namespace=`justknit` &topic=`calc`]]</button>
                    <input id="addBtn" type="submit" name="addCalc" class="btn btn-primary  mb-2" value="[[%justknit.btn_add? &namespace=`justknit` &topic=`calc`]]" />[[-`]]
                    <button id="clrBtn" type="reset" class="btn btn-secondary  mb-2">[[%justknit.btn_reset? &namespace=`justknit` &topic=`calc`]]</button>
                    <button id="modalBtn" type="button" class="btn btn-secondary  mb-2" data-bs-toggle="modal" data-bs-target="#helpModal">[[%justknit.btn_help? &namespace=`justknit` &topic=`calc`]]</button>[[-`]]
                </div>
            </nav>
        </footer>
        </form>
    </body>
    <!-- Bootstrap 5.3.0 -->
    <script src="assets/components/justknit/js/web/popper.min.js"></script>
    <script src="assets/components/justknit/js/web/bootstrap.min.js"></script>
    <script src="assets/components/justknit/js/web/html2pdf.bundle.min.js"></script>

    <script>
/* <![CDATA[ */
    var lex = [[!jsonLex]], res = [];
    res.id = [[*id]];
    res.alias = '[[*alias]]';
/* ]]> */
    </script>
    <script src="assets/components/justknit/js/web/justknit.js"></script>
    <script src="assets/components/justknit/js/web/calc.js"></script>
    <script>
        var toastElList = [].slice.call(document.querySelectorAll('.toast'))
        var toastList = toastElList.map(function (toastEl) { return new bootstrap.Toast(toastEl) })
        var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
        var popoverList = popoverTriggerList.map(function (popoverTriggerEl) { return new bootstrap.Popover(popoverTriggerEl) })
        var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
        var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) { return new bootstrap.Tooltip(tooltipTriggerEl) })
    </script>
</html>
