<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace JustKnit\Processors\Subscriber;

use MODX\Revolution\Processors\Model\CreateProcessor;
use JustKnit\Model\JustKnitSubscriberMeta;
use xPDO\Om\xPDOQuery;

class Create extends CreateProcessor {
    public $classKey = JustKnitSubscriberMeta::class;
    public $objectType = 'justknit.subscriber';
    /**
     * Override in your derivative class to do functionality before save() is run
     *
     * @return boolean
     */

    public function beforeSave()
    {
        $subscriber_name = $this->getProperty('subscriber_name');
        if (empty($subscriber_name)) {
            $this->addFieldError('subscriber_name', $this->modx->lexicon('justknit.subscriber_err_missing_subscriber_name'));
        }
    }

}

