/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */

var v = [], drws = [], text = '',success = false,tpl = lex["jk." + res.alias + "_result_tpl"], innerTpl = lex["jk." + res.alias + "_result_innertpl"];
var fs  = document.querySelectorAll('[id^="calc-"]');
var flds = document.querySelectorAll('.inVal'), shownFlds = document.querySelectorAll('.shown'),resultPs = document.querySelectorAll('.resultP');
/** BEGIN functions for basic calculations **/
function Gauge(gauge_len, gauge_qty, len) {
  this.len = len || 0;
  this.qty = Math.round(gauge_qty/gauge_len*len);
}
function DistributeDifference(sts, rows, gap, even){
    gap ? sts++ : sts*1;
    even ? even=even*2 : even=1;
    fields = {};
    fields[1] = {};
    fields[2] = {};
    var r2m = rows - even * sts;
    switch (true) {
        case (r2m < 0):
            fields[1].rows = even;
            fields[2].rows = even;
            fields[1].sts = Math.floor(sts * even / rows);
            fields[2].sts = fields[1].sts + 1
            fields[1].qty = Math.floor(rows/even-sts+(rows/even)*(fields[1].sts))
            fields[2].qty = Math.floor(sts-(rows/even)*(fields[1].sts))
            if (this.g) {if(fields[1].qty>0) { fields[1].qty--; sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        case (r2m == 0):
            fields[1].qty = sts;
            fields[2].qty = 0;
            fields[1].sts = 1;
            fields[2].sts = 0;
            fields[1].rows = rows/sts;
            fields[2].rows = 0;
            if (gap) {if(fields[1].qty>0) { fields[1].qty--;sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        case (r2m > 0):
            fields[1].sts = 1
            fields[2].sts = 1
            fields[1].rows = Math.floor((rows/sts)/even)*even
            fields[2].rows = fields[1].rows + even
            fields[2].qty = Math.floor((rows-sts*fields[1].rows)/even)
            fields[1].qty = Math.floor(sts-rows/even+sts/even*fields[1].rows)
            if (gap) {if(fields[1].qty>0) { fields[1].qty--;sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        default:
            break;
    }
    this.rt = fields;
}
function FiveSteps (qty_w,cap) {
    this.qty_w        = qty_w       || 0;
    this.capCap        = cap        || 0;
    var calcSteps      = [];
    if (cap) {
    var calcSteps      = { "1":{step:5, div:2},
                            "2":{step:4, div:1},
                            "3":{step:3, div:1},
                            "4":{step:2, div:1}};
    } else {
    var calcSteps      = { "1":{step:5, div:3},
                            "2":{step:4, div:3},
                            "3":{step:3, div:2},
                            "4":{step:2, div:2},
                            "5":{step:1, div:1}};
    }
    var sumRows = 0;
    var sumSts = 0;
    var sumCap = {};
    sumCap.rows = 0;
    sumCap.sts = 0;
    var rest = this.qty_w;
    var arcCal = new Object();
    var capCal = new Object();
    for(var i of Object.keys(calcSteps)) {
        var sc = new Object();
        var step = calcSteps[i];
        sc.stsRes = Math.floor(rest / step['div']);
        sc.qat = Math.floor(sc.stsRes / step['step']);
        sc.row = sc.qat * 2;
        sc.sts = step['step'];
        sumSts = sumSts + (sc.sts * sc.qat);
        sumRows = sumRows + sc.row;
        if (i == "4") {
            sumCap.rows = sumCap.rows + sumRows;
            sumCap.sts = sumCap.sts + sumSts;
        }
        arcCal[i] = sc;
        if (i!=="5"){
            capCal[i] = sc;
        }
        rest = rest - (step['step'] * sc.qat);
    }
    this.stepResult = Object.assign({}, arcCal);
    this.capResult = Object.assign({}, capCal);
    this.qty_h = sumRows;
    this.cap = sumCap;
}
/** END basic calculations **/

/** BEGIN functions for each calculation depending resource alias **/
function maschen_berechnen() {
    var v = getValues(flds);
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.sts_len) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    var fields = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.sts_len);
    fields.gauge_len_h = 0;
    fields.sts_qty = fields.qty;
    fields.sts_dtn_d = 'w';
    var fields = getCalc(fields,v,drws,tpl);
    return true;
}
function reihen_berechnen() {
    var v = getValues(flds);
    if (!v.gauge_len_h || !v.gauge_qty_h || !v.rows_len) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    var fields = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.rows_len);
    fields.gauge_len_w = 0;
    fields.rows_qty = fields.qty;
    fields.rows_dtn_d = 'h';
    var fields = getCalc(fields,v,drws,tpl);
}
function zunahmen_berechnen() {
    var v = getValues(flds);
    if (!v.sts_qty || !v.rows_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    var fields = new DistributeDifference(v.sts_qty, v.rows_qty, v.gap, v.even);
    fields.rows_dtn_d = 'h';
    fields.sts_dtn_d = 'w';
    fields.gauge_len_w = 0;
    fields.gauge_len_h = 0;
    fields.sts_len = 0;
    fields.rows_len = 0;

    for (var rslt of Object.keys(fields.rt)) {
        resjson = JSON.stringify(fields.rt[rslt]);
        if (fields.rt[rslt].qty !== 0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    var fields = getCalc(fields,v,drws,tpl);
    return true;
}
function abnahmen_berechnen() {
    var v = getValues(flds);
    if (!v.sts_qty || !v.rows_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    var fields = new DistributeDifference(v.sts_qty, v.rows_qty, v.gap, v.even);
    fields.rows_dtn_d = 'h';
    fields.sts_dtn_d = 'w';
    fields.gauge_len_w = 0;
    fields.gauge_len_h = 0;
    fields.sts_len = 0;
    fields.rows_len = 0;

    for (var rslt of Object.keys(fields.rt)) {
        resjson = JSON.stringify(fields.rt[rslt]);
        if (fields.rt[rslt].qty !==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    var fields = getCalc(fields,v,drws,tpl);
    return true;
}
function verteilt_zunehmen() {
    var v = getValues(flds);
    if (!v.sts_qty || !v.inc_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    if (v.inc_qty > v.sts_qty || v.inc_qty == v.sts_qty) {
        showError(lex["jk.alert_inc_num"]);
        return false;
    }
    v.even = 0;
    var fields = new DistributeDifference(v.inc_qty, v.sts_qty, v.gap, v.even);
    fields.inc_dtn_d = 'w';
    fields.sts_dtn_d = 'w';
    fields.gauge_len_w = 0;
    fields.gauge_len_h = 0;
    fields.sts_len = 0;
    fields.inc_len = 0;
    var text = '', sum = 0;
    for (var rslt of Object.keys(fields.rt)) {
        resjson = JSON.stringify(fields.rt[rslt]);
        if (fields.rt[rslt].qty !==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
            sum += (fields.rt[rslt].qty * fields.rt[rslt].rows);
        }
    }
    if (v.gap) {
        fields.rest = v.sts_qty - sum;
        tpl += lex["jk." + res.alias + "_result_tpl_rest"];
//        if () {}
    }
    
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    var fields = getCalc(fields,v,drws,tpl);
    tpl = lex["jk." + res.alias + "_result_tpl"]
    return true;    
}
function verteilt_abnehmen() {
    var v = getValues(flds);
    if (!v.sts_qty || !v.dec_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    if (v.dec_qty > v.sts_qty || v.dec_qty == v.sts_qty) {
        showError(lex["jk.alert_inc_num"]);
        return false;
    }
    v.even = 0;
    var fields = new DistributeDifference(v.dec_qty, v.sts_qty, v.gap, v.even);
    fields.dec_dtn_d = 'w';
    fields.sts_dtn_d = 'w';
    fields.gauge_len_w = 0;
    fields.gauge_len_h = 0;
    fields.sts_len = 0;
    fields.inc_len = 0;
    var text = '', sum = 0;
    
    for (var rslt of Object.keys(fields.rt)) {
        fields.rt[rslt].rows2 = fields.rt[rslt].rows-1;
        resjson = JSON.stringify(fields.rt[rslt]);
        if (fields.rt[rslt].qty !==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
            sum += (fields.rt[rslt].qty * fields.rt[rslt].rows);
        }
    }
    if (v.gap) {
        fields.rest = v.sts_qty - sum;
        tpl += lex["jk." + res.alias + "_result_tpl_rest"];
//        if () {}
    }
    
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    var fields = getCalc(fields,v,drws,tpl);
    tpl = lex["jk." + res.alias + "_result_tpl"]
    return true;    
}
function runder_halsausschnitt() {
    var v = getValues(flds), fields = {};
    drws = ['wNeck','hNeckFront'];
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.wNeck_len || !v.gauge_len_h || !v.gauge_qty_h || !v.hNeckFront_len) {
        showError(lex["jk.alert_novalue"]);
        resetResult();
        return false;
    }
    fields.wNeck = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wNeck_len);

    fields.wNeck_qty = fields.wNeck.qty - (fields.wNeck.qty % 2);
    fields.hNeckFront  = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.hNeckFront_len);
    fields.hNeckFront_qty  = fields.hNeckFront.qty - (fields.hNeckFront.qty % 2);
    fields.centerBindOff = Math.round(fields.wNeck_qty /3);
    fields.side = Math.round((fields.wNeck_qty - fields.centerBindOff)/2);
    fields.centerBindOff = (fields.wNeck_qty - (fields.side*2))
    fields.Neck_dec = new FiveSteps(fields.side,0);
    // 2 cm Höhe für den Standard hinteren Halsausschnitt
    fields.decBack = Math.round((v.gauge_qty_h / v.gauge_len_h * 2 ) / 2);
    fields.centerBackBindOff = fields.wNeck_qty - fields.decBack * 2;
    for (var rslt of Object.keys(fields.Neck_dec.stepResult)) {
        resjson = JSON.stringify(fields.Neck_dec.stepResult[rslt]);
        if (fields.Neck_dec.stepResult[rslt].qat!==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    fields.hdec = fields.Neck_dec.qty_h +2; //Für die in der mitte abgeketteten
    fields.hleft = fields.hNeckFront_qty - fields.hdec;
// Hier unsinnige Eingaben abfangen
    if (fields.hleft < 0 ) {
        showError(lex["jk.alert_min_row"]);
        resetResult();
        return false;
    }
    fields = getCalc(fields,v,drws,tpl);
    if (fields.gauge_results.includes('{') || fields.gauge_results.includes('}') || fields.centerBackBindOff < 0) {
        showError(lex["jk.alert_wrong_value"]);
        resetResult();
        return false;
    }
    return true;
}
function v_ausschnitt() {
    var v = getValues(flds), fields = {};
    drws = ['wNeck','hNeckFront'];
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.wNeck_len || !v.gauge_len_h || !v.gauge_qty_h || !v.hNeckFront_len) {
        showError(lex["jk.alert_novalue"]);
        resetResult();
        return false;
    }
    fields.wNeck = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wNeck_len);

    fields.wNeck_qty = fields.wNeck.qty - (fields.wNeck.qty % 2);
    fields.hNeckFront  = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.hNeckFront_len);
    fields.hNeckFront_qty  = fields.hNeckFront.qty - (fields.hNeckFront.qty % 2);
    fields.stsVneck = fields.wNeck_qty /2;
    fields.vNeck_dec = new DistributeDifference(fields.stsVneck, fields.hNeckFront_qty, 1, 1);
    // 2 cm Höhe für den Standard hinteren Halsausschnitt
    fields.decBack = Math.round((v.gauge_qty_h / v.gauge_len_h * 2 ) / 2);
    fields.centerBackBindOff = fields.wNeck_qty - fields.decBack * 2;

    for (var rslt of Object.keys(fields.vNeck_dec.rt)) {
        resjson = JSON.stringify(fields.vNeck_dec.rt[rslt]);
        if (fields.vNeck_dec.rt[rslt].qty !==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    fields = getCalc(fields,v,drws,tpl);
    if (fields.gauge_results.includes('{') || fields.gauge_results.includes('}') || fields.centerBackBindOff < 0) {
        showError(lex["jk.alert_wrong_value"]);
        resetResult();
        return false;
    }
    return true;

}
function hinterer_halsausschnitt() {
    var v = getValues(flds), fields = {};
    drws = ['wNeck','hNeckBack'];
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.wNeck_len || !v.gauge_len_h || !v.gauge_qty_h || !v.hNeckBack_len) {
        showError(lex["jk.alert_novalue"]);
        resetResult();
        return false;
    }
    fields.wNeck = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wNeck_len);
    fields.wNeck_qty = fields.wNeck.qty - (fields.wNeck.qty % 2);
    fields.hNeckBack  = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.hNeckBack_len);

    // Hälfte Reihenzahl als Abnahmen
    fields.decBack = Math.round(fields.hNeckBack.qty /2);
    fields.centerBindOff = fields.wNeck_qty - 2 * fields.decBack;
    fields = getCalc(fields,v,drws,tpl);
    if (fields.gauge_results.includes('{') || fields.gauge_results.includes('}') || fields.centerBackBindOff < 0) {
        showError(lex["jk.alert_wrong_value"]);
        resetResult();
        return false;
    }
    return true;
}
function schulterschraege() {
    var v = getValues(flds), fields = {};
    drws = ['wShoulder','hShoulder'];
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.gauge_len_h || !v.gauge_qty_h || !v.hShoulder_len || !v.wShoulder_len) {
        showError(lex["jk.alert_novalue"]);
        resetResult();
        return false;
    }
    fields.wShoulder = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wShoulder_len);
    fields.hShoulder = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.hShoulder_len);
    v.even = 1;
    v.gap = 0;
    fields.Shoulder = new DistributeDifference(fields.wShoulder.qty, fields.hShoulder.qty, v.gap, v.even);

    for (var rslt of Object.keys(fields.Shoulder.rt)) {
        resjson = JSON.stringify(fields.Shoulder.rt[rslt]);
        if (fields.Shoulder.rt[rslt].qty !==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    fields = getCalc(fields,v,drws,tpl);    
}
function armausschnitt_berechnen() {
    var v = getValues(flds);
    var fields = new FiveSteps(v.wArmhole_qty,0);
    fields.gauge_len_w = 0;
    fields.gauge_len_h = 0;
    fields.wArmhole_len = 0;
    for (var rslt of Object.keys(fields.stepResult)) {
        resjson = JSON.stringify(fields.stepResult[rslt]);
        if (fields.stepResult[rslt].qat!==0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    fields.innertpl = text;
    fields.hArmhole_qty = fields.qty_h;
    var fields = getCalc(fields,v,drws,tpl);
}
function armloch_mit_armkugel() {
    var v = getValues(flds);
    drws = ['hArmhole','wArmhole','wUpperarm','hCap'];
    // basic validation
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.gauge_len_h || !v.gauge_qty_h || !v.wArmhole_len || !v.hArmhole_len || !v.wUpperarm_len || !v.hCap_len) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    if (v.wArmhole_len*2 >= v.wUpperarm_len) {
        showError(lex["jk.alert_w_armhole_upperarm"]);
        return false;
    }
    if (v.hArmhole_len*2 < v.wUpperarm_len) {
        showError(lex["jk.alert_h_armhole_upperarm"]);
        return false;
    }
    if (v.hArmhole_len < v.hCap_len) {
        showError(lex["jk.alert_h_armhole_cap"]);
        return false;
    }
/*
    if () {
        showError(lex["jk.   "]);
        return false;
    }
*/
    var fields = {};
    fields.Cap = {};
/**
 * Zuerst alle Längen mit der MaPro umrechnen
 * Maschen und Reihen: [hArmhole_qty, wArmhole_qty, wUpperarm_qty, hCap_qty]
 * Reihenzahl Höhe Armloch muss gerade sein
 */
    fields.hArmhole  = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.hArmhole_len);
    fields.hArmhole_qty = fields.hArmhole.qty;
    fields.wArmhole  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wArmhole_len);
    fields.wArmhole_qty  = fields.wArmhole.qty;
    fields.wUpperarm = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wUpperarm_len);
    fields.wUpperarm_qty  = fields.wUpperarm.qty;
    fields.hCap      = new Gauge(v.gauge_len_h ,v.gauge_qty_h,v.hCap_len);
//    fields.hCap_qty  = fields.hCap.qty;
    fields.hCap_qty = fields.hCap.qty - (fields.hCap.qty % 2);
/**
 * Abnahmen für Armloch berechnen
 * Summe wird nicht überprüft, weil die Anzahl gleich ist.
 */
    fields.Armhole_dec = new FiveSteps(fields.wArmhole_qty,0);
    fields.armhole_sumRows = fields.Armhole_dec.qty_h;
    fields.armhole_leftRows = fields.hArmhole_qty - fields.armhole_sumRows;
/**
 * Armkugel berechnen
 * 1/3 Oberarm = obere Armkugel, davon 1/2 abketten, jeweils 1/2 vom Rest rechts und links abnehmen
 * Wenn ungerade Maschenzahl am Oberarm, 1 Masche zu den abgeketteten dazu addieren
 */
    fields.Cap.UpRnd = Math.floor(fields.wUpperarm_qty / 3);
    fields.Cap.bindOff = Math.floor(fields.Cap.UpRnd / 2) + Math.abs(fields.wUpperarm.qty % 2);
    fields.Cap.distRest = Math.floor((fields.Cap.UpRnd - fields.Cap.bindOff) / 2);
    fields.Cap.Up_dec = new FiveSteps(fields.Cap.distRest,1);
    fields.Cap.Up_rows = 2 + fields.Cap.Up_dec.cap.rows;
    fields.Cap.Up_sts = fields.Cap.bindOff + fields.Cap.Up_dec.cap.sts * 2;

    fields.Cap.stsToDist = Math.floor((fields.wUpperarm_qty - fields.Cap.bindOff) / 2) - fields.Armhole_dec.cap.sts - fields.Cap.Up_dec.cap.sts;
    fields.Cap.rowsToDist = (fields.hCap_qty - 2) - fields.Armhole_dec.cap.rows - fields.Cap.Up_dec.cap.rows;
    fields.btw_dec = new DistributeDifference(fields.Cap.stsToDist, fields.Cap.rowsToDist, 0, 1);

    fields.bindOff = fields.Cap.bindOff;
    fields.total = 0;
    tplArr = {};
    tplArr.final = tpl;
    tplArr.parts = {
        'innertpl1':{0:lex["jk." + res.alias + "_result_innertpl1"],1:fields.Armhole_dec.stepResult},
        'innertpl2':{0:lex["jk." + res.alias + "_result_innertpl2"],1:fields.Armhole_dec.capResult},
        'disdiff':{0:lex["jk." + res.alias + "_disdiff"],1:fields.btw_dec.rt},
        'innertpl3':{0:lex["jk." + res.alias + "_result_innertpl3"],1:fields.Cap.Up_dec.stepResult}};
    for (var p of Object.keys(tplArr.parts)) {
        text = '';
        //console.log('parts p: ', p, lexicon.parts);
        if (p.includes('innertpl') && typeof(tplArr.parts[p][1]) !== "undefined") {
            for (var rslt of Object.keys(tplArr.parts[p][1])) {
                resJ = JSON.stringify(tplArr.parts[p][1][rslt]);
                if (tplArr.parts[p][1][rslt].qat!==0){
                    text = text+getGaugeResult(tplArr.parts[p][0],resJ)+', ';
                    if (p !== 'innertpl1') {
                        fields.total += tplArr.parts[p][1][rslt].qat * tplArr.parts[p][1][rslt].sts;
                    }
                }
            }
        }
        if (p == 'disdiff' && typeof(tplArr.parts[p][1]) !== "undefined") {
            for (var rt of Object.keys(tplArr.parts[p][1])) {
                resJ = JSON.stringify(tplArr.parts[p][1][rt]);
                if (tplArr.parts[p][1][rt].qty!==0){
                    text = text+getGaugeResult(tplArr.parts[p][0],resJ)+', ';
                    fields.total += tplArr.parts[p][1][rt].qty * tplArr.parts[p][1][rt].sts;
                }
            }
        }
        if (p == 'innertpl3') {
            text = text.slice(0, text.length-2);
            var textArr = text.split(', ');
            textArr = textArr.reverse();
            text = textArr.join(', ');
        }
        text = text.slice(0, text.length-2);
        fields[p] = text;
    }
    fields.total = fields.total * 2 + fields.bindOff;
    //fields = getCalc(fields,v,drws,tpl);
    fields = getCalc(fields,v,drws,tpl);
    return true;
}
function armloch_mit_schraege() {
    var v = getValues(flds);
    var fields = {};
    //drws = ['wArmhole','wUpperarm','hCap','hArmhole'];
    fields.wArmhole = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wArmhole_len);
    fields.wUpperarm = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wUpperarm_len);
    fields.hCap = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.hCap_len);
    fields.hArmhole = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.hArmhole_len);
    fields.wArmholeThird = Math.floor(fields.wArmhole.qty / 3);
    fields.wArmholeRest = fields.wArmhole.qty - fields.wArmholeThird;
    fields.wArmholeRows = fields.wArmholeRest * 2 + 2;
    fields.hArmholeleftRows = fields.hArmhole.qty - fields.wArmholeRows;
    fields.wUpperarm_sts = fields.wUpperarm.qty;
    fields.wUpperarm_stsRest = fields.wUpperarm_sts - 2 * (fields.wArmholeThird + fields.wArmholeRest);
    var fields = getCalc(fields,v,drws,tpl);
}
function maschenanschlag_rvo() {
    var v = getValues(flds);
    var drws = ['back','armright','armleft','frontleft','frontright','frontmid'];
    // basic validation
    //gauge_len_w,gauge_qty_w,wNeckScope_len,wRaglanLine_qty,wRaglanSleeve_len
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.wNeckScope_len || !v.wRaglanSleeve_len || !v.wRaglanLine_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    } //wBust_len,wUpperarm_len,hArmhole_len,wCrossback_len,wNeck_len,wRaglanSleeve_len,wRaglanLine_qty`
    var fields = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wNeckScope_len);;
    // sts for raglan line
    fields.RaglanSt = v.wRaglanLine_qty
    fields.RaglanSts = 4*fields.RaglanSt;
    // wide of sleeve
    fields.armG = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wRaglanSleeve_len);
    fields.arm = fields.armG.qty;
    fields.armleft = fields.arm;
    fields.armright = fields.arm;
    // distribute front/back
    fields.back = Math.floor((fields.qty - fields.arm*2 - fields.RaglanSts)/2);
    fields.CastOn = fields.back + fields.RaglanSts + fields.arm * 2 + 2;
    fields.NeckCo = Math.floor((fields.back-2)/2)+ (fields.back-2) %2 + (fields.qty - fields.arm*2 - fields.RaglanSts) %2;
    fields.incFrontQty = Math.floor((fields.back - 2 - fields.NeckCo)/2);
    fields.FrontPartQty = fields.incFrontQty*2+1;
    fields.frontleft = fields.FrontPartQty;
    fields.frontright = fields.FrontPartQty;
    fields.frontmid = fields.NeckCo;
    fields.sum1 = fields.CastOn + fields.NeckCo;
    fields.diff1 = fields.qty - fields.sum1;
    fields.FrontInc = Math.floor(fields.qty - fields.sum1)/4;
    fields.mvor = fields.back + fields.ScopeSts % 3 + fields.back % 2 + 2 * Math.round(1.5 * v.gauge_qty_w / v.gauge_len_w);
    fields.rest = fields.ScopeSts % 3;
    fields.RoundTot = fields.qty + 8*fields.incFrontQty;

    var fields = getCalc(fields,v,drws,tpl);

}
function raglan_von_unten() {
    // Calculate
    var calc = calcRaglanYoke();

    return calc.success;
}
function raglan_von_oben() {
    // Calculate
    var calc = calcRaglanYoke(); //jk.raglan_von_oben_rows_table_inner

    return calc.success;
}


//Für den Beginn des Armausschnitts beidseitig 5 M Maschen abketten. Dann 12 x 1 M jede 2. Reihe abnehmen.86 M (=35,5 cm) nach dem Armausschnitt.
/** END funcions calc-resource **/
/** BEGIN functions used in resource calculations **/

/**
 * getCalc - Die Ergebnisse der Berechnung werden in die
 * entsprechenden Felder eingetragen.
 * @access public
 * @return array
 */

function getCalc(result,v,drws,tpl) {
    for (var drw in drws) {
        if (result[drws[drw]]) {
            result[drws[drw]+'-s'] = result[drws[drw]];
        } else {
            result[drws[drw]+'-s'] = v[drws[drw]+'_len'];
        }
    }
    result.allFields = gatherVal(result,v);
    for (var drw in drws) {
//        result[drws[drw]+'-s'] = v[drws[drw]+'_len'];
        if (result[drws[drw]]) {
            result[drws[drw]+'-s'] = result[drws[drw]];
        } else {
            result[drws[drw]+'-s'] = v[drws[drw]+'_len'];
        }
    }
    for (skt of Object.keys(result.allFields)) {
        if (skt.includes('-s')){
            if (document.getElementById(skt)){
            document.getElementById(skt).innerHTML = result.allFields[skt];
            }
        }
    }
    result.gauge_pattern_meta = JSON.stringify(result.allFields);
    result.gauge_results = getGaugeResult(tpl,result.gauge_pattern_meta);
    fillFields(result, v,flds);
    var resultPs = document.querySelectorAll('.resultP');
    for(var resultP of resultPs){
        resultP.innerHTML = result.gauge_results;
    }
    return result;
}
/**
 * setResultValues - Die Ergebnisse der Berechnung werden in die entsprechenden result felder eingetragen.
 */

function gatherVal(result,v) {
    //dafür muss je nach Formular bestimmt werden welches Ergebnis in welches Feld muss.
    //anschließend muss daraus ein json string gemacht werden. ???
    var allFlds = {};
    for (let i in v) {
        allFlds[i] = v[i];
    }
    for (let i in result) {
        allFlds[i] = result[i];
    }
// remove objectfields and tplfields
    for (let i in allFlds) {
        if ((typeof allFlds[i]) == 'object'){
            allFlds[i] = '';
        }
        if (allFlds[i] == '' || typeof allFlds[i] == 'undefined'){
            delete allFlds[i];
        }
    }
    return allFlds;

}

/**
 * Get the Values of all FormFields with class .inVal for caculation
 * @access public
 * @return array 
 */
function getValues(flds) {
    let v = [];
    for(var fld of flds) {
        switch (fld.type) {
            case "checkbox":
                fld.checked ? v [fld.id] = 1 : v [fld.id] = 0;
                break;
            case "number":
                v [fld.id] = fld.value * 1;
                break;
            default:
                v [fld.id] = fld.value;
                break;
        }
    }
    return v;
}
/**
 * getGaugeResult - Die Felder im lexiconstring für Das Ergebnis
 * werden mit den Ergebnissen ersetzt. .
 */
function getGaugeResult(lexiconstring, results){
    text = lexiconstring;
    JSON.parse(results, (key, value) => {
        text = text.replaceAll("{"+key+"}",value);
    });
    return text;
}
/**
 * fillFields - Alle Felder werden in die inputs übertragen.
 */
function fillFields(result,v,flds) {
    var allFields = Object.assign(v,result);
    for(var fld of flds) {
        fld.value = allFields[fld.id];
//        console.log(fld.value,fld.id);
    }
}
/**
 * showError - shows an Alert with error message
 */
function showError(message) {
    document.getElementById('calcError').innerHTML =  message;
    document.getElementById('error').classList.add('show');
    resetResult();
}

function resetResult() {
    for(var resultP of resultPs){
        resultP.innerHTML = '&nbsp;';
    }
}

function calcRaglanYoke() {
    var v = getValues(flds);
    var drws = ['wBust','wUpperarm','hArmhole','wCrossback','wNeck','wRaglanSleeve'];
    //wBust,wUpperarm,hArmhole,wCrossback,wNeck,wRaglanSleeve,wRaglanLine
    // basic validation
    if (!v.gauge_len_w || !v.gauge_qty_w || !v.gauge_len_h || !v.gauge_qty_h || !v.wBust_len || !v.hArmhole_len || !v.wUpperarm_len || !v.wCrossback_len || !v.wNeck_len || !v.wRaglanSleeve_len || !v.wRaglanLine_qty) {
        showError(lex["jk.alert_novalue"]);
        return false;
    }
    if (v.wBust_len <= v.wCrossback_len) {
        showError(lex["jk.alert_w_crossback_bust"]);
        return false;
    }
    if (v.hArmhole_len - (v.wRaglanSleeve_len / 2) <= (v.wCrossback_len - v.wNeck_len) / 2) {
        showError(lex["jk.alert_h_armhole_crossback"]);
        return false;
    }
    if (v.wNeck_len >= v.wBust_len || v.wNeck_len >= v.wCrossback_len) {
        showError(lex["jk.alert_w_neck_bust_crossback"]);
        return false;
    }
    if (v.wRaglanSleeve_len >= v.wUpperarm_len) {
        showError(lex["jk.alert_w_arm_raglan"]);
        return false;
    }
    var fields = {};
    fields.wBust  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wBust_len);
    fields.wUpperarm  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wUpperarm_len);
    fields.wNeck  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wNeck_len);
    fields.wRaglanSleeve  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,v.wRaglanSleeve_len);
    //wRaglanSleeve_len
    if (fields.wRaglanSleeve.qty - v.wRaglanLine_qty <= 0 || fields.wNeck.qty - v.wRaglanLine_qty <= 0) {
        showError(lex["jk.alert_raglanline_qty"]);
        return false;
    }
    // Achselmaschen
    fields.armpit = Math.floor((v.wBust_len - v.wCrossback_len) / 8);
    if (fields.armpit == 0) {
        fields.armpit = 1;
    }
    fields.wArmpit  = new Gauge(v.gauge_len_w ,v.gauge_qty_w,fields.armpit);
    // Höhe Raglanpasse
    fields.yoke = v.hArmhole_len - (v.wRaglanSleeve_len / 2);
    fields.hYoke  = new Gauge(v.gauge_len_h ,v.gauge_qty_h,fields.yoke);
    // Maschen am Rückenteil für die Abnahme
    fields.Back_stsToDist = Math.floor((fields.wBust.qty - (2 * fields.wArmpit.qty) - fields.wNeck.qty) / 2);
    fields.Back_dec = new DistributeDifference(fields.Back_stsToDist, fields.hYoke.qty, 0, 1);
    // Maschen am Ärmel für die Abnahme
    fields.Arm_stsToDist = Math.floor((fields.wUpperarm.qty - (2 * fields.wArmpit.qty) - fields.wRaglanSleeve.qty) / 2);
    fields.Arm_dec = new DistributeDifference(fields.Arm_stsToDist, fields.hYoke.qty, 0, 1);
    fields.wBust_qty = fields.wBust.qty;
    fields.wUpperarm_qty = fields.wUpperarm.qty;
    fields.wArmpit_qty = fields.wArmpit.qty;
    fields.wBust_qty_yoke = fields.wBust.qty - fields.wArmpit.qty * 2;
    fields.wUpperarm_qty_yoke = fields.wUpperarm.qty - fields.wArmpit.qty * 2;
    fields.sumYoke = (fields.wBust_qty_yoke + fields.wUpperarm_qty_yoke) * 2;
    fields.RL_qty = v.wRaglanLine_qty;
    fields.wBust_qty_RL = fields.wBust_qty_yoke - fields.RL_qty;
    fields.wUpperarm_qty_RL = fields.wUpperarm_qty_yoke - fields.RL_qty;
    fields.wRaglanSleeve_qty = fields.wRaglanSleeve.qty;
    fields.wNeck_qty = fields.wNeck.qty;
    fields.hYoke_qty = fields.hYoke.qty;
    fields.hYoke_len = fields.hYoke.len;
    fields.sumNeck = (fields.wNeck.qty + fields.wRaglanSleeve.qty) *2;
    fields.wArm_qty_RL = fields.wRaglanSleeve.qty - v.wRaglanLine_qty;
    fields.wNeck_qty_RL = fields.wNeck.qty - v.wRaglanLine_qty;
    var Back_text = '';
    var Back_lexinner = lex["jk." + res.alias + "_result_Back_innertpl"];
    for (var rslt of Object.keys(fields.Back_dec.rt)) {
        resjson = JSON.stringify(fields.Back_dec.rt[rslt]);
        if (fields.Back_dec.rt[rslt].qty !==0) {
            Back_text = Back_text+getGaugeResult(Back_lexinner,resjson)+', ';
        }
    }
    Back_text = Back_text.slice(0, Back_text.length-2);
    fields.Back_innertpl = Back_text;

    var Arm_text = '';
    var Arm_lexinner = lex["jk." + res.alias + "_result_Arm_innertpl"];
    for (var rslt of Object.keys(fields.Arm_dec.rt)) {
        resjson = JSON.stringify(fields.Arm_dec.rt[rslt]);
        if (fields.Arm_dec.rt[rslt].qty !==0) {
            Arm_text = Arm_text+getGaugeResult(Arm_lexinner,resjson)+', ';
        }
    }
    Arm_text = Arm_text.slice(0, Arm_text.length-2);
    fields.Arm_innertpl = Arm_text;

    var Row_text = '';
    var tVal = {};
    // 2 stitches less for the first dec/inc
    if (res.alias == 'raglan_von_unten') {
        tVal.sts_back = fields.wBust_qty_RL - 2;
        tVal.sts_arm = fields.wUpperarm_qty_RL - 2;
    } else {
        tVal.sts_back = fields.wNeck_qty_RL - 2;
        tVal.sts_arm = fields.wArm_qty_RL - 2;
    }
    tVal.RL_qty = fields.RL_qty;
    Row_lexinner = lex["jk." + res.alias + "_rows_table_innertpl"];
    for (let i = 1; i <= (fields.hYoke_qty / 2); i++) {
        tVal.rowNum = i*2;

            if (i <= fields.Back_dec.rt[1].qty) {
                    tVal.back_sts_dec = fields.Back_dec.rt[1].sts
                    tVal.back_sts_next = fields.Back_dec.rt[1].sts * 2
                    tVal.nextRowBack = tVal.rowNum + fields.Back_dec.rt[1].rows
            } else {
                if (tVal.rowNum == tVal.nextRowBack) {
                    tVal.back_sts_dec = fields.Back_dec.rt[2].sts
                    tVal.back_sts_next = fields.Back_dec.rt[2].sts * 2
                    tVal.nextRowBack = tVal.rowNum + fields.Back_dec.rt[2].rows
                } else {
                    tVal.back_sts_dec = 0;
                    tVal.back_sts_next = 0;
                }

            }
        if (i <= fields.Arm_dec.rt[1].qty) {
            tVal.arm_sts_dec = fields.Arm_dec.rt[1].sts
            tVal.arm_sts_next = fields.Arm_dec.rt[1].sts * 2
            tVal.nextRowArm = tVal.rowNum + fields.Arm_dec.rt[1].rows
        } else {
            if (tVal.rowNum == tVal.nextRowArm) {
            tVal.arm_sts_dec = fields.Arm_dec.rt[2].sts
            tVal.arm_sts_next = fields.Arm_dec.rt[2].sts * 2
            tVal.nextRowArm = tVal.rowNum + fields.Arm_dec.rt[2].rows
            } else {

            tVal.arm_sts_dec = 0;
            tVal.arm_sts_next = 0;
            }
        }


        if (res.alias == 'raglan_von_unten') {
            tVal.dec = 8;
            tVal.sts_back = tVal.sts_back - tVal.back_sts_next;
            tVal.sts_arm = tVal.sts_arm - tVal.arm_sts_next;
        } else {
            tVal.dec = 8;
            tVal.sts_back = tVal.sts_back + tVal.back_sts_next;
            tVal.sts_arm = tVal.sts_arm + tVal.arm_sts_next;
        }
        tVal.sts_sum = tVal.sts_back*2 + tVal.sts_arm*2 + tVal.RL_qty*4 + tVal.dec;
        tValjson = JSON.stringify(tVal);
        Row_text = Row_text+getGaugeResult(Row_lexinner,tValjson);
    }

    fields.row_line_content = Row_text;

// Ärmel haben dann {wUpperarm_qty_yoke}
// Rückenteil haben je {wBust_qty_yoke}

    var fields = getCalc(fields,v,drws,tpl);
    fields.success = true;
    return fields;
}

/** END functions used in resource calculations **/

/**
 * BEGIN Prepare form and fields
 * Alles was mit den Berechnungen zu tun hat.
 **/

//var fnc = new Function("return function " + res.alias + "(" + flds + ")");
//var name = res.alias;
/*var fnc = new Function(
     "return function " + res.alias + "(){ alert('sweet!')}"
)();
*/
if (fs) {
    for (var f of fs) {
    var btns = ['calcBtn','clrBtn','addBtn','prtBtn','copyBtn'];
    for (var b of btns) {
      var btn = document.getElementById(b);
      if (btn) {
      switch(b) {
        case 'calcBtn':
          btn.addEventListener('click', function (e) {
            document.getElementById('error').classList.remove('show');
            eval(res.alias+'()');
            e.preventDefault();
          })
          break;
        case 'clrBtn':
          btn.addEventListener('click', function (e) {
            for (var shown of shownFlds) {
                shown.value = '';
                shown.defaultValue = '';
                if (shown.id.includes('-s')) {
                    shown.innerHTML = "&nbsp;";
                }
            }
            for(var resultP of resultPs) {
                resultP.innerHTML = "&nbsp;";
            }
            document.getElementById('error').classList.remove('show');
          })
          break;
        case 'addBtn':
          btn.addEventListener('click', function (e) {
            document.getElementById('error').classList.remove('show');
            success = eval(res.alias+'()');
            if (success) {
                f.submit();
            }
          })
          break;
        case 'prtBtn':
          btn.addEventListener('click', function (e) {
            var kaVal = getKnitApp();
            var darkThemeSelected = (kaVal !== null && kaVal.theme === 'dark');
              if (document.getElementById('iPrint').hidden) {
                  if (darkThemeSelected) {
                      document.documentElement.dataset.appliedMode = 'dark';
                }
                  document.body.classList.remove('print');
                  document.getElementById('iPrint').hidden = false;
                  document.getElementById('iWeb').hidden = true;
              } else {

                  if (darkThemeSelected) {
                      document.documentElement.dataset.appliedMode = 'light';
                }
                  document.body.classList.add('print');
                  document.getElementById('iPrint').hidden = true;
                  document.getElementById('iWeb').hidden = false;
                  var printcalc = document.getElementById('prt-'+res.alias);
                  var opt = {
                      margin: 10,
                      filename: 'JustKnit-'+res.alias+'.pdf',
                      image: {type: 'jpeg', quality: 1},
                      html2canvas: {
                          scale: 4,
                          dpi: 72,
                          letterRendering: true
                      },
                      html2canvas: {
                          onclone: (printcalc) => {
                              const svgElements = Array.from(printcalc.querySelectorAll('svg'));
                              svgElements.forEach(s => {
                                  const bBox = s.getBBox();
                                  s.setAttribute("x", bBox.x);
                                  s.setAttribute("y", bBox.y);
                                  s.setAttribute("width", bBox.width);
                                  s.setAttribute("height", bBox.height);
                              })
                          }
                      }
                  };
                  html2pdf().set(opt).from(printcalc).save();
              }
          })
          break;
        case 'copyBtn':
          btn.addEventListener('click', function (e) {
            var result = document.getElementById('result');
            navigator.clipboard.writeText(result.innerHTML);
            this.setAttribute("title", result.innerHTML);
            var tt = bootstrap.Tooltip.getInstance(this);
            tt.show();
          })
          break;
        default:

      }
    }
    }
  }
}
for(var fld of flds) {
  fld.addEventListener('change', function (e) {
      this.classList.remove('is-invalid');
// Maschenprobe Breite oder Höhe muss >3 sein
      if ((this.id.includes('gauge_len') || this.id.includes('hNeckFront_len')) && this.value <= 3){
          var divID = document.getElementById('D'+this.id);
          if (divID) {divID.innerHTML = lex["jk.inv_gauge_len"];}
          this.classList.add('is-invalid');
      }
// Wert von 0 ist nicht zugelassen
      if (this.value == 0 || this.value == '') {
          if (this.id == 'gap' || this.id == 'even'){
          } else {
          var divID = document.getElementById('D'+this.id);
          if (divID) {divID.innerHTML = lex["jk.inv_0"];}
          this.classList.add('is-invalid');
          }
      }
      var drw = document.getElementById(this.id.slice(0, -4)+'-s');

      if (drw) {
        drw.innerHTML = this.value;


        if (res.alias == 'armloch_mit_schraege') {
            if (drw.id == 'wUpperarm-s') {
                document.getElementById('hArmhole-s').innerHTML = this.value / 2;
                document.getElementById('hArmhole_len').value = this.value / 2;
            }
            if (drw.id == 'wArmhole-s') {
                document.getElementById('hCap-s').innerHTML = this.value;
                document.getElementById('hCap_len').innerHTML = this.value;
            }
        }
      }

  })
}

/** END Prepare form and fields **/


